/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN  
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_config.c 1 2010-06-14 02:33:52Z ertl-ichiba $
 */

/*
 *  ץå¸⥸塼Nios2ѡ
 */
#include "kernel_impl.h"
#include "check.h"
#include "task.h"
#include "nios2.h"

/*
 * 㳰ʳ/CPU㳰ˤΥͥȲΥ
 * ƥȻȤΤ˻
 */
uint32_t except_nest_count;

/*
 * Ƴߤγ׵ػߥե饰ξ
 */
uint32_t idf;

/*
 * ߤγͥ٥ޥ
 */
uint8_t iipm;
 
/*
 *  °ꤵƤ뤫Ƚ̤뤿ѿ
 */
uint32_t bitpat_cfgint;

#ifndef NIOS2_USE_INT_VEC_INST
/*
 *  װȽΤΥӥåȥޥåץ̿
 */
const uint8_t int_bitmap_search_table[] = { 0, 1, 0, 2, 0, 1, 0,
										3, 0, 1, 0, 2, 0, 1, 0 };
#endif

/*
 *  ץå¸ν
 */
void
prc_initialize()
{
	/*
	 *  ͥ뵯ư󥿥ƥȤȤư뤿1
	 */ 
	except_nest_count = 1;

	/*
	 * Ƴߤγ׵ػߥե饰ػ
	 */
	idf = ~0U;

	/*
	 * ͥ٥ޥν
	 */ 
	iipm = 0U;

	/*
	 * Ƥγߤޥ
	 */
	set_ienable(~0U);

	/*
	 *  °ꤵƤ뤫Ƚ̤뤿ѿ롥
	 */
	bitpat_cfgint = 0U;
}

/*
 *  ץå¸νλ
 */
void
prc_terminate(void)
{
	/*
	 *  ٤Ƥγߤޥ롥
	 */
	set_ienable(~0U);

    extern void    software_term_hook(void);
    void (*volatile fp)(void) = software_term_hook;

	/*
     *  software_term_hookؤΥݥ󥿤򡤰övolatileΤfp
     *  ƤȤΤϡ0ȤӤŬǺʤ褦ˤ뤿
     *  Ǥ롥
     */
    if (fp != 0) {
        (*fp)();
    }  
}

/*
 *  ׵饤°
 *
 *  ASPͥǤѤꤷơѥ᡼顼ϥǥ
 *  Ƥ롥FI4ͥѤˤϡ顼֤褦ˤ٤
 *  Ǥ
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri)
{
	assert(VALID_INTNO(intno));
	assert(TMIN_INTPRI <= intpri && intpri <= TMAX_INTPRI);

	/*
	 *  °ꤵƤ뤫Ƚ̤뤿ѿ
	 */
	bitpat_cfgint |= INTNO_BITPAT(intno);

	/* 
	 * äߤػߤ
	 */    
	x_disable_int(intno);

	if ((intatr & TA_ENAINT) != 0U){
		(void)x_enable_int(intno);
	}
}

/*
 *  CPU㳰ȯΥ
 *
 *  CPU㳰ϥɥ椫顤CPU㳰ݥ󥿡p_excinfˤȤ
 *  ƸƤӽФȤǡCPU㳰ȯ򥷥ƥ˽Ϥ롥
 */
#ifdef SUPPORT_XLOG_SYS

void
xlog_sys(void *p_excinf)
{    
}

#endif /* SUPPORT_XLOG_SYS */

#ifndef OMIT_DEFAULT_EXC_HANDLER

/*
 * ̤㳰äν
 */
void
default_exc_handler(void *p_excinf){

	syslog(LOG_EMERG, "Unregistered Exception occurs.");
	syslog(LOG_EMERG, " Excno = %d.",
		   *(((uint32_t*)p_excinf) + CPUEXC_FLM_EXCNO));
	syslog(LOG_EMERG, " ESTATUS = 0x%x.",
		   *(((uint32_t*)p_excinf) + CPUEXC_FLM_ESTATUS));
	syslog(LOG_EMERG, " Addr = 0x%x.",
		   *(((uint32_t*)p_excinf) + CPUEXC_FLM_PC));
	syslog(LOG_EMERG, " IPM = 0x%x.",
			 *(((uint32_t*)p_excinf) + CPUEXC_FLM_IPM));
	syslog(LOG_EMERG, " Interrupt/Exception Nest Count = %d",
			 *(((uint32_t*)p_excinf) + CPUEXC_FLM_NEST));
	target_exit();
}

#endif /* OMIT_DEFAULT_EXC_HANDLER */

#ifndef OMIT_DEFAULT_INT_HANDLER

/*
 * ̤γߤäν
 */
void
default_int_handler(void *p_excinf){
	syslog(LOG_EMERG, "Unregistered Interrupt occurs.");
	syslog(LOG_EMERG, " Intno = %d.", *((int*)p_excinf));
	target_exit();
}

#endif /* OMIT_DEFAULT_INT_HANDLER */
